# Mapbox GL Native

[![Travis](https://api.travis-ci.org/mapbox/mapbox-gl-native.svg?branch=master)](https://travis-ci.org/mapbox/mapbox-gl-native/builds) [![Bitrise](https://www.bitrise.io/app/7514e4cf3da2cc57.svg?token=OwqZE5rSBR9MVWNr_lf4sA&branch=master)](https://www.bitrise.io/app/7514e4cf3da2cc57)

An OpenGL-based renderer for [Mapbox Vector Tiles](https://www.mapbox.com/blog/vector-tiles), consisting of a C++ library for OS X and Linux and SDK bindings for iOS, Android and Node.js.

**This repository is for development on Mapbox GL Native itself.**

If you want to use products _based on_ Mapbox GL, check out:

- [Mapbox Mobile](http://mapbox.com/mobile) — iOS and Android native development libraries
- [`mapbox-gl-native`](https://www.npmjs.com/package/mapbox-gl-native) - Node.js native module
- [`react-native-mapbox-gl`](https://github.com/mapbox/react-native-mapbox-gl) — React Native library
- [`qmapboxgl`](https://github.com/tmpsantos/qmapboxgl) — Qt library
- [`Mapbox Cordova Plugin`](http://plugins.telerik.com/cordova/plugin/mapbox) - Telerik's Apache Cordova plugin

--

## Targets

* Ubuntu Linux
* OS X 10.9+
* iOS 7.0+
  * iPhone 4S and above (5, 5c, 5s, 6, 6 Plus)
  * iPad 2 and above (3, 4, Mini, Air, Mini 2, Air 2)
  * iPod touch 5th gen and above
* Android 4.0.3+ (API level 15+)

See [`INSTALL.md`](./INSTALL.md) for development setup and install instructions, including dependencies.
